/**********************************************************************
 * perditiondb_posix_gegex.h                              December 1999
 * Horms                                             horms@vergenet.net
 *
 * Access a posix_gegex(3) database
 *
 * Released under the terms of the GNU GPL
 *
 **********************************************************************/

#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <ctype.h>
#include <regex.h>
#include <stdio.h>
#include <perdition_adt.h>

#define PERDITIONDB_POSIX_REGEX_MAPNAME "/etc/perdition/popmap.re"
#define PERDITIONDB_POSIX_REGEX_MAX_LINE_LENGTH 4096
#define PERDITIONDB_POSIX_REGEX_MAX_FIELD_DELIMITER ':'

int dbserver_get(
  char *key_str, 
  char *options_str,
  char **str_return, 
  int *len_return
);

/*
 * #defines to destroy and dupilcate regex
 * Funtions that are not possible are substituted with noop funtions
 */
#define DESTROY_REGEX (void (*)(void *s))destroy_regex
#define DUP_REGEX (void *(*)(void *s))dummy_dup_regex

/*
 * #defines to destroy and dupilcate keyvalue stucture
 */
#define DESTROY_KV (void (*)(void *s))key_value_destroy
#define DUP_KV (void *(*)(void *s))key_value_duplicate

static regex_t *dummy_dup_regex(regex_t *preg);
static void destroy_regex(regex_t *preg);

